#ifndef CONFIGGUIOPTS_H
#define CONFIGGUIOPTS_H

#include <QObject>
#include <QString>
#include <QStringList>
#include <QSettings>

class ConfigGuiOpts : public QObject
{
    Q_OBJECT
    Q_PROPERTY(bool showNotificationOnFileDownloaded READ getShowNotificationOnFileDownloaded WRITE setShowNotificationOnFileDownloaded);
    Q_PROPERTY(bool showNotificationOnFileDecoded READ getShowNotificationOnFileDecoded WRITE setShowNotificationOnFileDecoded);
    Q_PROPERTY(bool showTrayIcon READ getShowTrayIcon WRITE setShowTrayIcon);
    Q_PROPERTY(QString hostname1 READ getHostname1 WRITE setHostname1);
    Q_PROPERTY(QString hostname2 READ getHostname2 WRITE setHostname2);
    Q_PROPERTY(QString hostname3 READ getHostname3 WRITE setHostname3);
    Q_PROPERTY(QString hostname4 READ getHostname4 WRITE setHostname4);
    Q_PROPERTY(QString hostname5 READ getHostname5 WRITE setHostname5);
    Q_PROPERTY(bool showColumnProgress READ getShowColumnProgress WRITE setShowColumnProgress);
    Q_PROPERTY(bool showColumnSubject READ getShowColumnSubject WRITE setShowColumnSubject);
    Q_PROPERTY(bool showColumnPoster READ getShowColumnPoster WRITE setShowColumnPoster);
    Q_PROPERTY(bool showColumnNewsgroups READ getShowColumnNewsgroups WRITE setShowColumnNewsgroups);
    Q_PROPERTY(bool showColumnFilesize READ getShowColumnFilesize WRITE setShowColumnFilesize);
    Q_PROPERTY(bool showColumnFilesizeRemaining READ getShowColumnFilesizeRemaining WRITE setShowColumnFilesizeRemaining);
    Q_PROPERTY(bool showColumnStamp READ getShowColumnStamp WRITE setShowColumnStamp);
    Q_PROPERTY(bool showColumnTimeRemaining READ getShowColumnTimeRemaining WRITE setShowColumnTimeRemaining);
    Q_PROPERTY(bool showColumnTimeToFinish READ getShowColumnTimeToFinish WRITE setShowColumnTimeToFinish);
    Q_PROPERTY(QString autoImportDirectory READ getAutoImportDirectory WRITE setAutoImportDirectory);
    Q_PROPERTY(bool enableAutoImport READ getEnableAutoImport WRITE setEnableAutoImport);
    Q_PROPERTY(QString lastUsedNzbDirectory READ getLastUsedNzbDirectory WRITE setLastUsedNzbDirectory);
    Q_PROPERTY(bool showConnectDialog READ getShowConnectDialog WRITE setShowConnectDialog);
    Q_PROPERTY(QStringList autoLoadPlugins READ getAutoLoadPlugins WRITE setAutoLoadPlugins);
    Q_PROPERTY(bool hideInactiveConnections READ getHideInactiveConnections WRITE setHideInactiveConnections);

public:
    ConfigGuiOpts();
    ~ConfigGuiOpts();

    bool getShowNotificationOnFileDownloaded() const;
    void setShowNotificationOnFileDownloaded(bool showNotificationOnFileDownloaded);

    bool getShowNotificationOnFileDecoded() const;
    void setShowNotificationOnFileDecoded(bool showNotificationOnFileDecoded);

    bool getShowTrayIcon() const;
    void setShowTrayIcon(bool showTrayIcon);

    QString getHostname1() const;
    void setHostname1(QString hostname1);

    QString getHostname2() const;
    void setHostname2(QString hostname2);

    QString getHostname3() const;
    void setHostname3(QString hostname3);

    QString getHostname4() const;
    void setHostname4(QString hostname4);

    QString getHostname5() const;
    void setHostname5(QString hostname5);

    bool getShowColumnProgress() const;
    void setShowColumnProgress(bool showColumnProgress);

    bool getShowColumnSubject() const;
    void setShowColumnSubject(bool showColumnSubject);

    bool getShowColumnPoster() const;
    void setShowColumnPoster(bool showColumnPoster);

    bool getShowColumnNewsgroups() const;
    void setShowColumnNewsgroups(bool showColumnNewsgroups);

    bool getShowColumnFilesize() const;
    void setShowColumnFilesize(bool showColumnFilesize);

    bool getShowColumnFilesizeRemaining() const;
    void setShowColumnFilesizeRemaining(bool showColumnFilesizeRemaining);

    bool getShowColumnStamp() const;
    void setShowColumnStamp(bool showColumnStamp);

    bool getShowColumnTimeRemaining() const;
    void setShowColumnTimeRemaining(bool showColumnTimeRemaining);

    bool getShowColumnTimeToFinish() const;
    void setShowColumnTimeToFinish(bool showColumnTimeToFinish);

    QString getAutoImportDirectory() const;
    void setAutoImportDirectory(QString autoImportDirectory);

    bool getEnableAutoImport() const;
    void setEnableAutoImport(bool enableAutoImport);

    QString getLastUsedNzbDirectory() const;
    void setLastUsedNzbDirectory(QString lastUsedNzbDirectory);

    bool getShowConnectDialog() const;
    void setShowConnectDialog(bool showConnectDialog);

    QStringList getAutoLoadPlugins() const;
    void setAutoLoadPlugins(QStringList autoLoadPlugins);

    bool getHideInactiveConnections() const;
    void setHideInactiveConnections(bool hideInactiveConnections);

    QByteArray getGeometry(QString objectName) const;
    void setGeometry(QString objectName, QByteArray geometry);

    QByteArray getState(QString objectName) const;
    void setState(QString objectName, QByteArray state);

    int getCurrentTabIndex() const;
    void setCurrentTabIndex(int index);

private:
    QSettings *settings;
};

#endif // CONFIGGUIOPTS_H
