#ifndef DOWNLOADQUEUEITEM_H
#define DOWNLOADQUEUEITEM_H

#include <QVariant>
#include "QNNTPGrabGlue.h"

class DownloadQueueItem
{
public:
    DownloadQueueItem(DownloadQueueItem *parent = 0);
    ~DownloadQueueItem();

    void appendChild(DownloadQueueItem *child);
    void insertChild(int position, DownloadQueueItem *child);
    bool removeChild(DownloadQueueItem *child);

    DownloadQueueItem *child(int row);
    int childCount() const;
    int columnCount() const;
    QVariant data(int column) const;
    int row() const;
    DownloadQueueItem *parent();
    DownloadQueueItem *lookupSubject(QString subject);
    int rowOfChild(DownloadQueueItem *child) const;

    QString subject;
    QString poster;
    QString groups;
    qint64 size;
    qint64 sizeRemaining;
    QDateTime stamp;
    int progress;
    QString realFilename;

    QString stateStr;
    QString sizeStr;
    QString sizeRemainingStr;
    QString estimatedTimeRemainingStr;
    QString estimatedTimeToFinishStr;

    enum field {
        FIELD_STATE_STR,
        FIELD_SUBJECT,
        FIELD_POSTER,
        FIELD_GROUPS,
        FIELD_FILE_SIZE_STR,
        FIELD_FILE_SIZE_REMAINING_STR,
        FIELD_STAMP,
        FIELD_ESTIMATED_TIME_REMAINING_STR,
        FIELD_ESTIMATED_TIME_TO_FINISH_STR,
        FIELD_PROGRESS,
        FIELD_FILE_SIZE,
        FIELD_FILE_SIZE_REMAINING,
        FIELD_REAL_FILENAME,
        NUM_FIELDS
    };

private:
    QList<DownloadQueueItem*> childItems;
    DownloadQueueItem *parentItem;
};

#endif // DOWNLOADQUEUEITEM_H
