#include "DownloadQueueSelectionModel.h"

DownloadQueueSelectionModel::DownloadQueueSelectionModel(DownloadQueueModel *model, QObject *parent) :
    QItemSelectionModel(model, parent)
{
    connect(model, SIGNAL(rowsAboutToBeMoved(const QModelIndex&,int,int,const QModelIndex&,int)), SLOT(onRowsAboutToBeMoved(const QModelIndex&,int,int,const QModelIndex&,int)));
    connect(model, SIGNAL(rowsMoved(const QModelIndex&,int,int,const QModelIndex&,int)), SLOT(onRowsMoved(const QModelIndex&,int,int,const QModelIndex&,int)));
}

void DownloadQueueSelectionModel::onRowsAboutToBeMoved(const QModelIndex &sourceParent, int sourceStart, int sourceEnd, const QModelIndex &destinationParent, int destinationRow)
{
    Q_UNUSED(sourceEnd);
    Q_UNUSED(destinationParent);
    Q_UNUSED(destinationRow);

    /* Is the current row selected? */
    QModelIndex idx = sourceParent.child(sourceStart, 0);
    if (!idx.isValid()) {
        idx = model()->index(sourceStart, 0);
        if (!idx.isValid()) {
            qWarning("DownloadQueueSelectionModel::onRowsAboutToBeMoved: Invalid index (sourceParent)");
        }
    }

    if (isSelected(idx)) {
        /* Deselect the row and keep track of it so we can re-select it after the move has completed */
        select(idx, Toggle | Rows);
        deselectedSourceParent = sourceParent;
        deselectedSourceStart = sourceStart;

        if (destinationRow > sourceStart) {
            destinationRow--;
        }

        QModelIndex idx = destinationParent.child(destinationRow, 0);
        if (!idx.isValid()) {
            idx = model()->index(destinationRow, 0);
            if (!idx.isValid()) {
                qWarning("DownloadQueueSelectionModel::onRowsAboutToBeMoved: Invalid index (destinationParent)");
            }
        }
        select(idx, Toggle | Rows);
    } else {
        deselectedSourceParent = QModelIndex();
        deselectedSourceStart = -1;
    }
}

void DownloadQueueSelectionModel::onRowsMoved(const QModelIndex &sourceParent, int sourceStart, int sourceEnd, const QModelIndex &destinationParent, int destinationRow)
{
    Q_UNUSED(sourceEnd);
    Q_UNUSED(destinationParent);
    Q_UNUSED(destinationRow);

    /* Was the original row selected? */
    if (deselectedSourceParent != sourceParent ||
        deselectedSourceStart != sourceStart) {

        return;
    }

//    QModelIndex idx = destinationParent.child(destinationRow, 0);
//    if (!idx.isValid()) {
//        idx = model()->index(destinationRow, 0);
//        if (!idx.isValid()) {
//            qWarning("DownloadQueueSelectionModel::onRowsMoved: Invalid index (destinationParent)");
//        }
//    }
//    select(idx, Toggle | Rows);
}
