#ifndef WIDGETCONFIGAUTOIMPORT_H
#define WIDGETCONFIGAUTOIMPORT_H

#include <QWidget>
#include <QDirModel>
#include "QNNTPGrabGlue.h"
#include "AutoImport.h"

class MainWindow;   /* Prevent recursion */

namespace Ui {
    class WidgetConfigAutoImport;
}

class WidgetConfigAutoImport : public QWidget {
    Q_OBJECT
public:
    WidgetConfigAutoImport(MainWindow *mainwindow, QNNTPGrabGlue *glue, QWidget *parent = 0);
    ~WidgetConfigAutoImport();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::WidgetConfigAutoImport *ui;
    QDirModel *model;
    QNNTPGrabGlue *glue;
    AutoImport auto_import;

private slots:
    void configChanged();
    void chkEnableAutoImportLocal_clicked(bool toggled);
    void treeViewAutoImportLocal_clicked(QModelIndex idx);
    void radMoveFileAfterImport_toggled(bool);
    void chkEnableAutoImportServer_clicked(bool toggled);
    void editAutoImportServer_textChanged(QString text);
    void btnAutoImportServerApply_clicked();
};

#endif // WIDGETCONFIGAUTOIMPORT_H
