/*
    Copyright (C) 2005-2012  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _NNTPCONNECTION_BACKEND_NATIVE_H_
#define _NNTPCONNECTION_BACKEND_NATIVE_H_

#include "nntpconnection_backend_iface.h"

G_BEGIN_DECLS

#define NNTPCONNECTION_TYPE_BACKEND_NATIVE            (nntpconnection_backend_native_get_type())
#define NNTPCONNECTION_BACKEND_NATIVE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), NNTPCONNECTION_TYPE_BACKEND_NATIVE, NntpconnectionBackendNative))
#define NNTPCONNECTION_BACKEND_NATIVE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), NNTPCONNECTION_TYPE_BACKEND_NATIVE, NntpconnectionBackendNativeClass))
#define NNTPCONNECTION_IS_BACKEND_NATIVE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NNTPCONNECTION_TYPE_BACKEND_NATIVE))
#define NNTPCONNECTION_IS_BACKEND_NATIVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NNTPCONNECTION_TYPE_BACKEND_NATIVE))
#define NNTPCONNECTION_GET_BACKEND_NATIVE_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), NNTPCONNECTION_TYPE_BACKEND_NATIVE, NntpconnectionBackendNativeClass))

typedef struct _NntpconnectionBackendNative NntpconnectionBackendNative;
typedef struct _NntpconnectionBackendNativeClass NntpconnectionBackendNativeClass;

typedef struct _NntpconnectionBackendNativePrivate NntpconnectionBackendNativePrivate;

struct _NntpconnectionBackendNative {
    NntpConnection parent;

    /*< private >*/
    NntpconnectionBackendNativePrivate *priv;
};

GType nntpconnection_backend_native_get_type (void);
NntpConnection* nntpconnection_backend_native_new (void);

G_END_DECLS

#endif /* _NNTPCONNECTION_BACKEND_GIO_H_ */
