/*
    Copyright (C) 2005-2012  Erik van Pienbroek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>

#include "nntpconnection_utils.h"

void
nntpconnection_utils_strip_newline(char *line, int *length)
{
    g_return_if_fail(line != NULL);

    if (line[strlen(line) - 1]  == '\n') {
        line[strlen(line) - 1] = '\0';
        if (length) *length = *length - 1;
    }

    if (line[strlen(line) - 1]  == '\r') {
        line[strlen(line) - 1] = '\0';
        if (length) *length = *length - 1;
    }
}

int
nntpconnection_utils_get_status_code(const char *line)
{
    /* The status code is mentioned at the first 3 characters of the line.
     * atoi() doesn't detect errors and quits parsing after the first invalid
     * character which is enough for us */
    if (!line) {
        return -1;
    }

    return atoi(line);
}
